Main Page Namespace List Compound List File List Namespace Members Compound Members File Members

# TNT::Array3D Class Template Reference

`#include <tnt_array3d.h>`

List of all members.

## Public Types

typedef T | value_type

## Public Methods

| Array3D ()
| Array3D (int m, int n, int k)
| Array3D (int m, int n, int k, T *a)
| Array3D (int m, int n, int k, const T &a)
| Array3D (const Array3D &A)
Array3D& | operator= (const T &a)
Array3D& | operator= (const Array3D &A)
Array3D& | ref (const Array3D &A)
Array3D | copy () const
Array3D& | inject (const Array3D &A)
T** | operator[] (int i)
const T* const* | operator[] (int i) const
int | dim1 () const
int | dim2 () const
int | dim3 () const
| ~Array3D ()

## Detailed Description

### template<class T> class TNT::Array3D

Tempplated three-dimensional, numerical array which looks like a conventional C multiarray. Storage corresponds to conventional C ordering. That is the right-most dimension has contiguous elements. Indexing is via the A[i][j][k] notation.

Array assignment is by reference (i.e. shallow assignment). That is, B=A implies that the A and B point to the same array, so modifications to the elements of A will be reflected in B. If an independent copy is required, then B = A.copy() can be used. Note that this facilitates returning arrays from functions without relying on compiler optimizations to eliminate extensive data copying.

The indexing and layout of this array object makes it compatible with C and C++ algorithms that utilize the familiar C[i][j][k] notation. This includes numerous textbooks, such as Numercial Recipes, and various public domain codes.

## Member Typedef Documentation

template<class T>
typedef T TNT::Array3D<T>::value_type

## Constructor & Destructor Documentation

template<class T>
TNT::Array3D< T >::Array3D<T> ( | )

| Create a null (0x0x0) array.

template<class T>
TNT::Array3D< T >::Array3D<T> ( | int m,
| int n,
| int k )

Create a new (m x n x k) array, WIHOUT initializing array elements. To create an initialized array of constants, see Array3D(m,n,k, value).

This version avoids the O(m*n*k) initialization overhead and is used just before manual assignment.

Parameters:

  m | the first dimension of the new matrix.
  n | the second dimension of the new matrix.
  k | the third dimension of the new matrix.

template<class T>
TNT::Array3D< T >::Array3D<T> ( | int m,
| int n,
| int k,
| T * a )

Create a new (m x n x k) array, as a view of an existing one-dimensional array stored in C order, i.e. right-most dimension varying fastest. (Often referred to as "row-major" ordering.) Note that the storage for this pre-existing array will never be garbage collected by the Array3D class.

Parameters:

  m | the first dimension of the new matrix.
  n | the second dimension of the new matrix.
  k | the third dimension of the new matrix.
  a | the one dimensional C array to use as data storage for the array.

template<class T>
TNT::Array3D< T >::Array3D<T> ( | int m,
| int n,
| int k,
| const T & val )

Create a new (m x n x k) array, initializing array elements to constant specified by argument. Most often used to create an array of zeros, as in A(m, n, k, 0.0).

Parameters:

  m | the first dimension of the new matrix.
  n | the second dimension of the new matrix.
  k | the third dimension of the new matrix.
  val | the constant value to set all elements of the new array to.

template<class T>
TNT::Array3D< T >::Array3D<T> ( | const Array3D<T> & A )`[inline]`

| Copy constructor. Array data is NOT copied, but shared. Thus, in Array3D B(A), subsequent changes to A will be reflected in B. For an indepent copy of A, use Array3D B(A.copy()), or B = A.copy(), instead.

template<class T>
TNT::Array3D<T>::~Array3D<T> ( | )

## Member Function Documentation

template<class T>
Array3D< T > TNT::Array3D< T >::copy ( | ) const

| Create a new of existing matrix. Used in B = A.copy() or in the construction of B, e.g. Array3D B(A.copy()), to create a new array that does not share data.

template<class T>
int TNT::Array3D< T >::dim1 ( | ) const`[inline]`

Returns:
  the size of the first dimension of the array.

template<class T>
int TNT::Array3D< T >::dim2 ( | ) const`[inline]`

Returns:
  the size of the second dimension of the array.

template<class T>
int TNT::Array3D< T >::dim3 ( | ) const`[inline]`

Returns:
  the size of the third (right-most) dimension of the array.

template<class T>
Array3D< T > & TNT::Array3D< T >::inject ( | const Array3D<T> & A )

Copy the elements to from one array to another, in place. That is B.inject(A), both A and B must conform (i.e. have identical dimensions).

This differs from B = A.copy() in that references to B before this assignment are also affected. That is, if we have

    	Array3D A(m,n,k);
    	Array3D C(m,n,k);
    	Array3D B(C);        // elements of B and C are shared.

then B.inject(A) affects both and C, while B=A.copy() creates a new array B which shares no data with C or A.

Parameters:

  A | the array from elements will be copied

Returns:
  an instance of the modifed array. That is, in B.inject(A), it returns B. If A and B are not conformat, no modifications to B are made.

template<class T>
Array3D< T > & TNT::Array3D< T >::operator= ( | const Array3D<T> & A )`[inline]`

| B = A is shorthand notation for B.ref(A).

template<class T>
Array3D< T > & TNT::Array3D< T >::operator= ( | const T & a )`[inline]`

| Assign all elemnts of A to a constant scalar.

template<class T>
const T *const * TNT::Array3D< T >::operator[] ( | int i ) const`[inline]`

template<class T>
T ** TNT::Array3D< T >::operator[] ( | int i )`[inline]`

| Used for A[i][j][k] indexing. The first [] operator returns a conventional pointer which can be dereferenced using the same [] notation. If TNT_BOUNDS_CHECK macro is define, the left-most index is checked that it falls within the array bounds (via the assert() macro.)

template<class T>
Array3D< T > & TNT::Array3D< T >::ref ( | const Array3D<T> & A )`[inline]`

Create a reference (shallow assignment) to another existing array. In B.ref(A), B and A shared the same data and subsequent changes to the array elements of one will be reflected in the other.

This is what operator= calls, and B=A and B.ref(A) are equivalent operations.

Returns:
  The new referenced array: in B.ref(A), it returns B.

The documentation for this class was generated from the following file:

- tnt_array3d.h